﻿using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridComboSwitchDemo
{
    public partial class Form1 : Form
    {
        ViewModel vm = new ViewModel();
        public Form1()
        {
            InitializeComponent();

            ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            ultraGrid1.BeforeEnterEditMode += UltraGrid1_BeforeEnterEditMode;
            //ultraGrid1.InitializeRow += UltraGrid1_InitializeRow;
            ultraGrid1.DataSource = vm.Data;
        }

        //private void UltraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        //{
        //    UltraGridCell cell = e.Row.Cells["Item2"];
            
        //    if (e.Row.Cells["Item1"].Value?.ToString() != "Type In")
        //    {
        //        cell.Column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
        //    }
        //    else
        //    {
        //        cell.Column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDown;
        //    }
        //}

        private void UltraGrid1_BeforeEnterEditMode(object sender, CancelEventArgs e)
        {
            UltraGridCell cell = ultraGrid1.ActiveCell;

            if(cell.Column.Key == "Item2")
            {
                UltraGridRow row = cell.Row;
                if(row.Cells["Item1"].Value?.ToString() != "Type In")
                {
                    cell.Column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
                }
                else
                {
                    cell.Column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDown;
                }
            }
        }

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            layout.Override.AllowAddNew = AllowAddNew.FixedAddRowOnTop;

            UltraGridBand band = layout.Bands[0];

            UltraGridColumn item1Column = band.Columns["Item1"];            
            UltraGridColumn item2Column = band.Columns["Item2"];

            UltraComboEditor item1Editor = new UltraComboEditor();
            item1Editor.ValueList = vm.Item1ComboData;

            UltraComboEditor item2Editor = new UltraComboEditor();            
            item2Editor.ValueList = vm.Item2ComboData;            

            item1Column.EditorComponent = item1Editor;
            item2Column.EditorComponent = item2Editor;
        }
    }
}
